﻿Imports System.Runtime.InteropServices
Imports System.Text

Public Class Form1
#Region "globale Variablen***************************************"
    Dim errMessage As String = ""
    Dim n As Integer = -1
    Dim sbKEY As StringBuilder = New StringBuilder()
    Dim chKEY(5000) As Char
    Dim dbINPUT(50) As Double
    'The array size of dbOUTPUT should be 1 more than its equivalent        'Die Arraygröße von dbOUTPUT sollte 1 größer sein als sein äquvalent-Array 
    '_ array in the DLL, because of the length prefix in Delphi. This       '_in der DLL, wegen dem längen prefix in Delphi. Dieses
    '_ length prefix defines the length of the dataset in memory.           '_längen prefix definiert die Länge vom Datensatz im Speicher.
    '_ Without this prevention the storage position in memory will be       '_Ohne diese Vorbeugung, würde die Speicherposition im Speicher 
    '_ overwritten.                                                         '_überschreiben werden. 
    Dim dbOUTPUT(50) As Double
    Dim z1 As Integer = New Integer()
    Dim z2 As Integer = New Integer()
    Dim s1 As Integer = New Integer()
    Dim s2 As Integer = New Integer()

#End Region
#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function

    'Important here are the two arrays of double and the one StringBuilder.                    'Wichtig sind hier die 2 Arrays of double und der eine StringBuilder.
    'The StringBuilder acts as an array of char for the Delphi DLL.                            'Der StringBuilder arbeitet wie ein Array of Char für die Delphi DLL.
    'The calls here are all call by value (no ref, no out).                                    'Die Aufrufe hier sind alle Aufrufe bei Wert (kein ref, kein out).
    <DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_CALCULATION_FANMOTOR( _
        s1 As Integer, s2 As Integer, _
        <MarshalAs(UnmanagedType.LPArray)> INPUT() As Double, _
        <MarshalAs(UnmanagedType.LPStr)> KEY As StringBuilder, _
        z1 As Integer, z2 As Integer, _
        <MarshalAs(UnmanagedType.LPArray)> OUTPUT() As Double) _
        As Integer
    End Function


#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()

    End Sub
#End Region
#Region "get_input_value*****************************************"
    'Reads the manually specified product data out of the fields                                      'Liest die manuell angegebenen Produktdaten aus den Feldern aus.
    Private Sub get_input_value()

        Array.Clear(dbINPUT, 0, dbINPUT.Length)
        Dim i As Integer = 0

        'Tries to fill the dbINPUT array with user input values. If the input                         'Versucht das dbINPUT Array mit den User-Input-Werten zu füllen. Wenn
        '_ fields are empty, the actual array position will be set with a                             '_die Input-Felder leer sind, wird in die aktuelle Arrayposition ein
        '_ default value.                                                                             '_Standard Wert gesetzt.
        Try
            If comboBoxOption.SelectedItem.ToString() <> "" Then
                dbINPUT(i) = Convert.ToDouble(comboBoxOption.SelectedItem.ToString())
            Else : dbINPUT(i) = 0
            End If
            i += 1
            If comboBoxMounting.SelectedItem.ToString() <> "" Then
                dbINPUT(i) = Convert.ToDouble(comboBoxMounting.SelectedItem.ToString())
            Else : dbINPUT(i) = 0
            End If
            i += 1
            If textBoxAirDensity.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxAirDensity.Text)
            Else : dbINPUT(i) = 0
            End If
            i += 1
            If textBoxAirTemperature.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxAirTemperature.Text)
            Else : dbINPUT(i) = 22
            End If
            i += 1
            If textBoxAltitude.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxAltitude.Text)
            Else : dbINPUT(i) = 333
            End If
            i += 1
            If textBoxAirVolume.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxAirVolume.Text)
            Else : dbINPUT(i) = 0
            End If
            i += 1
            If textBoxSpeedStep.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxSpeedStep.Text)
            Else : dbINPUT(i) = 1
            End If
            i += 1
            If textBoxPressureDifferenceStatic.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxPressureDifferenceStatic.Text)
            Else : dbINPUT(i) = 100
            End If
            i += 1
            If textBoxPressureDifferenceTotal.Text <> "" Then
                dbINPUT(i) = Convert.ToDouble(textBoxPressureDifferenceTotal.Text)
            Else : dbINPUT(i) = 100
            End If

            'Throws an exception with error message if a letter/character is set into                             'Löst eine Ausnahme mit Fehlermeldung aus, wenn ein Buchstabe / Zeichen 
            '_ one of the input fields.                                                                           '_in ein der Inputfelder gesetzt wird..
        Catch fe As FormatException
            errMessage = fe.ToString()
            MessageBox.Show("Only numerary input accepted!", "Wrong input value")
        End Try

        'Copies the array of chars to a StringBuilder to avoid wrong interpretations                          'Kopiert das Array of Char in einen StringBuilder um eine falsche
        '_ with the DLL.                                                                                      '_Interpretation mit der DLL zu vermeiden.
        sbKEY.Append(textBoxIdNo.Text)
        sbKEY.Append(chKEY, sbKEY.Length, chKEY.Length - sbKEY.Length)
    End Sub
#End Region
#Region "list_item_calculation_fanmotor**************************"
    Private Function list_item_calculation_fanmotor() As Integer
        Dim errCodeFanmotor As Integer = 99

        errCodeFanmotor = GET_CALCULATION_FANMOTOR(s1, s2, dbINPUT, sbKEY, z1, z2, dbOUTPUT) 'Send Input, get data and save the data in Output.    'Sende den Input, bekomme die Daten und speicher sie im Output.
        show_Results_Calculation_Fanmotor(errCodeFanmotor)

        'Clearing these arrays and StringBuilder for its next use                                             'Leert diese Arrays und StringBuilder für ihre nächste Benutzung.
        Array.Clear(dbOUTPUT, 0, dbOUTPUT.Length)
        Array.Clear(dbINPUT, 0, dbINPUT.Length)
        sbKEY.Clear()

        Return errCodeFanmotor
    End Function
#End Region
#Region "show_Results_Calculation_Fanmotor***********************"
    'Displays the whole data of a product in the text boxes.                                                  'Zeigt die ganzen Daten eines Produktes in den Textboxen an.
    Private Sub show_Results_Calculation_Fanmotor(errCodeFanmotorIntern As Integer)

        richTextBoxOutputData.Clear()

        textBoxErrCodeFanmotor.Text = errCodeFanmotorIntern.ToString()

        textBox0.Text = dbOUTPUT(0).ToString("#0.00")
        textBox2.Text = dbOUTPUT(2).ToString("#0.00")
        textBox3.Text = dbOUTPUT(3).ToString("#0.00")
        textBox4.Text = dbOUTPUT(4).ToString("#0.00")
        textBox5.Text = dbOUTPUT(5).ToString("#0.00")
        textBox6.Text = dbOUTPUT(6).ToString("#0.00")
        textBox7.Text = dbOUTPUT(7).ToString("#0.00")
        textBox8.Text = dbOUTPUT(8).ToString("#0.00")
        textBox9.Text = dbOUTPUT(9).ToString("#0.000")
        textBox10.Text = dbOUTPUT(10).ToString("#0.00")
        textBox11.Text = dbOUTPUT(11).ToString("#0.00")
        textBox12.Text = dbOUTPUT(12).ToString("#0.00")
        textBox32.Text = dbOUTPUT(32).ToString("#0.00")
        textBox33.Text = dbOUTPUT(33).ToString("#0.000")
        textBox34.Text = dbOUTPUT(34).ToString("#0.00")
        textBox35.Text = dbOUTPUT(35).ToString("#0.00")
        textBox36.Text = dbOUTPUT(36).ToString("#0.00")
        textBox37.Text = dbOUTPUT(37).ToString("#0.00")
        textBox38.Text = dbOUTPUT(38).ToString("#0.00")
        textBox39.Text = dbOUTPUT(39).ToString("#0.00")

        textBox24.Text = dbOUTPUT(24).ToString("#0.00")
        textBox25.Text = dbOUTPUT(25).ToString("#0.00")
        textBox26.Text = dbOUTPUT(26).ToString("#0.00")
        textBox27.Text = dbOUTPUT(27).ToString("#0.00")
        textBox28.Text = dbOUTPUT(28).ToString("#0.00")
        textBox29.Text = dbOUTPUT(29).ToString("#0.00")
        textBox30.Text = dbOUTPUT(30).ToString("#0.00")
        textBox31.Text = dbOUTPUT(31).ToString("#0.00")

        textBox16.Text = dbOUTPUT(16).ToString("#0.00")
        textBox17.Text = dbOUTPUT(17).ToString("#0.00")
        textBox18.Text = dbOUTPUT(18).ToString("#0.00")
        textBox19.Text = dbOUTPUT(19).ToString("#0.00")
        textBox20.Text = dbOUTPUT(20).ToString("#0.00")
        textBox21.Text = dbOUTPUT(21).ToString("#0.00")
        textBox22.Text = dbOUTPUT(22).ToString("#0.00")
        textBox23.Text = dbOUTPUT(23).ToString("#0.00")

        textBox13.Text = dbOUTPUT(13).ToString("#0.00")
        textBox14.Text = dbOUTPUT(14).ToString("#0.00")
        textBox15.Text = dbOUTPUT(15).ToString("#0.00")

        textBox40.Text = dbOUTPUT(40).ToString("#0.00")
        textBox41.Text = dbOUTPUT(41).ToString("#0.00")
        textBox42.Text = dbOUTPUT(42).ToString("#0.00")

        richTextBoxOutputData.Text += "KEY: " + sbKEY.ToString() + vbCrLf
        richTextBoxOutputData.Text += "--------------------------------------------------------------------" + vbCrLf
        richTextBoxOutputData.Text += "Input: 1=Pfa 2=Ptot 3=DrehzStufe:" + vbTab + dbINPUT(0).ToString("#0.00") + vbCrLf ' '0=Pfa 1=Ptot
        richTextBoxOutputData.Text += "Input: Installationsart:" + vbTab + dbINPUT(1).ToString("#0.00") + vbCrLf
        richTextBoxOutputData.Text += "Input: Luftdichte Rho [kg/m^3]:" + vbTab + dbINPUT(2).ToString("#0.00") + vbCrLf
        richTextBoxOutputData.Text += "Input: Lufttemperatur T [°C]:" + vbTab + dbINPUT(3).ToString("#0.00") + vbCrLf
        'Pay attention on this hop of dbINPUT index!                        'Beachte den Sprung von dbINPUT index!
        richTextBoxOutputData.Text += "Input: Volumenstrom [m^3/h]:" + vbTab + dbINPUT(5).ToString("#0.00") + vbCrLf
        'Pay attention on this hop of dbINPUT index!                        'Beachte den Sprung von dbINPUT index!
        richTextBoxOutputData.Text += "Input: Druckerhöhung psf [Pa]:" + vbTab + dbINPUT(7).ToString("#0.00") + vbCrLf
        richTextBoxOutputData.Text += "Input: Druckerhöhung pf [Pa]:" + vbTab + dbINPUT(8).ToString("#0.00") + vbCrLf
        richTextBoxOutputData.Text += "--------------------------------------------------------------------" + vbCrLf

        Dim i As Integer = 2
        richTextBoxOutputData.Text += "Output: Drehzahl [1/min]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Gesamtwirkunsgrad Eta_tot[%]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Gesamtwirkunsgrad Eta_stat[%]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Wirkungsgrad Motor  Eta_mot[%]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i = 7 'Pay attention on this hop!                         'Beachte den Sprung von dbINPUT index!
        richTextBoxOutputData.Text += "Output: Druckerhöhung psf [Pa]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Druckerhöhung pf [Pa]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Leistungsaufnahme [W]:" + vbTab + dbOUTPUT(i).ToString("#0.000") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Stromaufnahme [A]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Anlaufstrom [A]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Anlaufzeit [s]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ges [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Schallleistung ds [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Schallleistung ss [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 62,5 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 125  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 250  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 500  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 1000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 2000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 4000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ds bei 8000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 62,5 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 125  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 250  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 500  Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 1000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 2000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 4000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: LW ss bei 8000 Hz [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: EtaLr [%]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Wellenleistung Laufrad, Pab Mot [W]:" + vbTab + dbOUTPUT(i).ToString("#0.000") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Einlaufdüsendruck[Pa]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Betriebsfrequenz Frequenzumformer[Hz]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "max. zulässige Betriebsfrequenz Frequenzumformer[Hz]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Minimal zulässiger Abstand Ventilator-Gehäusewand[mm]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Steuerspannung [V]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Elektrische Leistungsaufnahme FW [kW]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Schalleistung-gesamt A-bewertet [dBA]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Schalleistung-Druckseite A-bewertet [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        i += 1
        richTextBoxOutputData.Text += "Output: Schalleistung-Saugseite A-bewertetdbA [dB]:" + vbTab + dbOUTPUT(i).ToString("#0.00") + vbCrLf
        richTextBoxOutputData.Text += "Output: Fehlerparameter:" + vbTab + dbOUTPUT(0).ToString()
    End Sub
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click    'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                 'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                       'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                           'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                    'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                    'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                     'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                      'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                         'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub
    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              /Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           /Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   /Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             /Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         /Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           /Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         /Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       /Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If

    End Sub
    Private Sub buttonGetCalculationFanmotor_Click(sender As System.Object, e As System.EventArgs) Handles buttonGetCalculationFanmotor.Click
        If (ComboBoxIdNo.Text <> "" And TextBox_DLL_Error_Code.Text = "0" And textBoxIdNo.Text <> "") Then         'When products are loaded and error code is 0, then proceed                                              'Wenn ein Produkt geladen ist und der ErrorCode "0" ist, fahre fort. 

            get_input_value()
            list_item_calculation_fanmotor()


        Else    'If no product is selected, clear the fields and throw a message             'Wenn kein Produkt ausgewählt ist, leere die Felder und gebe eine Nachricht aus. 
            textBoxIdNo.Clear()
            textBoxErrCodeFanmotor.Clear()
            richTextBoxOutputData.Clear()

            'Clears each text box corresponding to its group box                               'Leert jede TextBox entsprechend ihrer Gruppenbox.
            For Each textBoxes As TextBox In groupBox5.Controls.OfType(Of TextBox)()
                textBoxes.Clear()
            Next

            For Each textBoxes As TextBox In groupBox6.Controls.OfType(Of TextBox)()
                textBoxes.Clear()
            Next

            Dim sbMessageBox As System.Text.StringBuilder = New System.Text.StringBuilder()
            sbMessageBox.Append("A prerequisite is not set!")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("Please check if you've chosen a product")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("and if the database is bounded!")
            MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set")
        End If
    End Sub


    Private Sub buttonShowOutputData_Click(sender As System.Object, e As System.EventArgs) Handles buttonShowOutputData.Click
        Select Case richTextBoxOutputData.Visible
            Case True                                                   'If OutputData is visible;                                 'Wenn OutputData sichtbar ist,
                richTextBoxOutputData.Visible = False                   '_set the richTextBox unvisble                             '_setzte die richTextBox unsichtbar,
                buttonShowOutputData.Text = "Show Output Data"          '_and change the button caption to "Show Output Data"      '_und ändere die Tastenüberschrifft in "Show Output Data".

            Case False                                                  'If OutputData is unvisible;                               'Wenn OutputData unsichtbar ist,
                richTextBoxOutputData.Visible = True                    '_set the textbox visble                                   '_setzte die richTextBox sichtbar,
                buttonShowOutputData.Text = "Hide Output Data"          '_and change the button caption to "Hide Output Data"      '_und ändere die Tastenüberschrifft in "Hide Output Data".
        End Select
    End Sub

#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
        textBoxIdNo.Text = ComboBoxIdNo.Text
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub
#End Region
End Class
