﻿Imports System.Runtime.InteropServices

Public Class Form1
#Region "globale Variablen***************************************"
    Dim sbInputData As System.Text.StringBuilder = New System.Text.StringBuilder()
#End Region
#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.

    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_CALCULATION_FAN_ALONE_PC(<MarshalAs(UnmanagedType.AnsiBStr)> fanDescription As String, ByRef buffer As String) As Integer
    End Function
#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()
    End Sub
#End Region
#Region "list_item_Fan_Alone*************************************"
    Private Function list_item_Fan_Alone(sbInputDataIntern As System.Text.StringBuilder)
        Dim errCodeFanAlone As Integer = 99
        'converts the StringBuilder into a standard String                                               'Konvertiert den StringBuilder in einen Standard-String.
        Dim stringInputDataIntern As System.String = Convert.ToString(sbInputDataIntern)
        'initializes fanStringChar with 4000 empty characters                                            'Initialisiert einen fanStringChar mit 4000 leeren Zeichen.
        Dim buffer As String = New String(New Char(), 4000)

        'errCodeFanAlone is a received error code from the DLL.                                          'errCodeFanAlone ist ein, von der DLL erhaltener, error Code.
        'stringInputDataIntern has the StringBuilder's data. Its value will be                           'stringInputDataIntern hat die Daten vom StringBuilder. Sein Wert werden
        '_ changed when getting it back from the DLL and                                                 'geändert, wenn er von der DLL zurück kommt und
        '_ this value will be passed to the show_results function then.                                  'dieser Wert wird weiter and die show_results Funktion gegeben.

        errCodeFanAlone = GET_CALCULATION_FAN_ALONE_PC(stringInputDataIntern, buffer)
        show_results_Fan_Alone(buffer)

        TextBoxErrCodeFanAlone.Text = errCodeFanAlone.ToString
        Return errCodeFanAlone
    End Function
#End Region
#Region "show_results_Fan_Alone**********************************"
    'Displays the whole data from a product in the textboxes.                                    'Zeigt die ganzen Daten eines Produktes in den Textboxen an.
    Private Sub show_results_Fan_Alone(inputDataIntern)
        Dim number As Integer = 0
        'Result is an Array of String. Its length should be the amount of the text boxes.        'Result ist ein Arry of String. Seine länge sollte der Anzahl der Textboxen entsprechen.
        Dim result(29) As String
        'Splits inputDataIntern in an Array of String at each semicolon                          'Teilt InputDataIntern in einen Array of String, bei jedem Semikolon.
        Dim temparr() As String = inputDataIntern.Split(New Char() {";"})

        'Copies all data from temparr Array to result Array                                      'Kopiert alle Daten von temparr zu result Array.
        temparr.CopyTo(result, 0)
        'Clears all entries in the ListBox.                                                      'Leert alle Einträge in der ListBox.
        ListBox1.Items.Clear()
        'Fills each text box with values out of the Array. Only textbox2 gets the specified value from textBoxAirVolume    'Füllt die Textboxen von tabPage1 und tabPage2 mit den Werten aus dem Array. Nur die textBox2 bekommt den angegebenen Wert von textBoxAirVolume.
        TextBox1.Text = result(27)
        TextBox2.Text = TextBoxAirVolume.Text
        TextBox3.Text = result(0)
        TextBox4.Text = result(1)
        TextBox5.Text = result(2)
        TextBox6.Text = result(3)
        TextBox7.Text = result(4)
        TextBox8.Text = result(5)
        TextBox9.Text = result(6)
        TextBox10.Text = result(26)
        TextBox11.Text = result(18)
        TextBox12.Text = result(19)
        TextBox13.Text = result(20)
        TextBox14.Text = result(21)
        TextBox15.Text = result(22)
        TextBox16.Text = result(23)
        TextBox17.Text = result(24)
        TextBox18.Text = result(25)
        TextBox19.Text = result(9)
        TextBox20.Text = result(10)
        TextBox21.Text = result(11)
        TextBox22.Text = result(12)
        TextBox23.Text = result(13)
        TextBox24.Text = result(14)
        TextBox25.Text = result(15)
        TextBox26.Text = result(16)
        TextBox27.Text = result(17)
        TextBox28.Text = result(8)
        TextBox29.Text = result(7)
        '/*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        'Creates the String-Array "List" with the descriptions of the values, from the fans.              'Erstellt das String-Array "List" mit den Beschreibungen, der Werte, der Lüfter.
        Dim List(30) As String
        List(0) = "      (n [1/min])"
        List(1) = "      (Pe [W])"
        List(2) = "      (I [A])"
        List(3) = "      (ηe [%])"
        List(4) = "     (U control [V])"
        List(5) = "     (Md [Ncm])"
        List(6) = "     (ηo [%])"
        List(7) = "     (LwA(in+out) [dBA])"
        List(8) = "     (LwA(in) [dBA])"
        List(9) = "     (LwA(out) [dBA])"
        List(10) = "    (Lw_62.5_Hz (in) [dB])"
        List(11) = "    (Lw_125__Hz (in) [dB])"
        List(12) = "    (Lw_250__Hz (in) [dB])"
        List(13) = "    (Lw_500__Hz (in) [dB])"
        List(14) = "    (Lw_1000_Hz (in) [dB])"
        List(15) = "    (Lw_2000_Hz (in) [dB])"
        List(16) = "    (Lw_4000_Hz (in) [dB])"
        List(17) = "    (Lw_8000_Hz (in) [dB])"
        List(18) = "    (Lw_62.5_Hz (out) [dB])"
        List(19) = "    (Lw_125__Hz (out) [dB])"
        List(20) = "    (Lw_250__Hz (out) [dB])"
        List(21) = "    (Lw_500__Hz (out) [dB])"
        List(22) = "    (Lw_1000_Hz (out) [dB])"
        List(23) = "    (Lw_2000_Hz (out) [dB])"
        List(24) = "    (Lw_4000_Hz (out) [dB])"
        List(25) = "    (Lw_8000_Hz (out) [dB])"
        List(26) = "    (pf [Pa])"
        List(27) = "    (pfs[Pa])"
        List(28) = "    (qv [m³/h])"

        Dim counter As Integer

        For counter = 0 To 29 Step +1                              'A for-loop counts from 0 to 29 and                                                             'Eine for-Schleife zählt von 0 auf 29 und
            ListBox1.Items.Add(result(counter) + List(counter))    '_fills the listbox with the values from the dll and the descriptions from the array "List".    '_und füllt die Listbox mit den Werten von der DLL und den Beschreibungen aus dem Array "List".
        Next
    End Sub
#End Region
#Region "get_input_value*****************************************"
    'Reads the manually specified product data out of the fields                                                  'Liest die, in den Feldern, manuel, angebenen Produktdaten aus.
    Private Function get_input_value()
        sbInputData.Clear()
        'Writes into the StringBuilder and parts each data with a semicolon                                       'Schreibt in den StringBuilder und teilt jeden Daten mit einem Semikolon.
        sbInputData.Append(TextBoxIdNo.Text & ";")
        sbInputData.Append(ComboBoxOption.Text & ";")
        sbInputData.Append(ComboBoxMounting.Text & ";")
        sbInputData.Append(TextBoxAirDensity.Text & ";")
        sbInputData.Append(TextBoxAltitude.Text & ";")
        sbInputData.Append(TextBoxAirTemperature.Text & ";")
        sbInputData.Append(TextBoxPressureDifference.Text & ";")
        'Formated input                                                                                           'Formatiert Input
        sbInputData.Append(((Convert.ToDouble(TextBoxAirVolume.Text)) / 3600).ToString("#0.00000"))
        sbInputData.Append(";")
        sbInputData.Append(TextBoxSupplyVoltage.Text & ";")
        TextBoxInputData.Text = "fanDescription= " + sbInputData.ToString()
        Return sbInputData
    End Function
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click       'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                    'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                          'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                              'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                       'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                                'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                       'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                        'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                                'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                         'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                            'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                   'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub

    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              /Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           /Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   /Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             /Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         /Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           /Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         /Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       /Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If

    End Sub

    Private Sub ButtonGetCalculationFanAlonePC_Click(sender As System.Object, e As System.EventArgs) Handles ButtonGetCalculationFanAlonePC.Click   'When button "GetCalculationFanAlonePC" is clicked                                                     'Wenn die Taste "GetCalculationFanAlonePc" angeklickt wird 
        If (TextBoxElements.Text <> "" And TextBox_DLL_Error_Code.Text = "0") Then                                                                  'and if TextboxElements is not empty (products are loaded) and the shown Dll Error Code is 0,          'und die TextboxElements ist nicht leer (Produkte sind geladen) und der angezeigte Dll Error Code ist 0,
            sbInputData = get_input_value()                                                                                                         'gave sbInputData the manually specified product data out of the fields (get_input_value)              'gib sbInputData die, in den Feldern, manuell, angegebenen Produktdaten (get_input_value)
            list_item_Fan_Alone(sbInputData)                                                                                                        'and gave the values (sbInputData) to "list_item_Fan_Alone".                                           'und gib diese Werte (sbInputData) zu "list_item_Fan_Alone".            

        Else                                                                                                                                        'If TextboxElements is empty or the shown Dll Error Code is not "0",                                   'Wenn die TextBoxElements leer ist oder der angezeigte Dll Error Code ist nicht "0",
            For Each txt As TextBox In TabPage1.Controls.OfType(Of TextBox)()                                                                       'clear each TextBox from tabPage1 (Results Motor/Fan),                                                 'lösche den Inhalt jeder TextBox von tabPage1 (Results Motor/Fan),
                txt.Text = ""
            Next
            For Each txt As TextBox In TabPage2.Controls.OfType(Of TextBox)()                                                                       'clear each TextBox from tabPage2 (Octave Band),                                                       'lösche den Inhalt jeder Textbox von tabPage2 (Octave Band),
                txt.Text = ""
            Next
            ListBox1.Items.Clear()                                                                                                                  'clear the listbox from Results Motor/Fan,                                                             'leere den Inhalt der Liste von Results Motor/Fan,
            TextBoxErrCodeFanAlone.Clear()                                                                                                          'clear the textBoxErrCodeFanAlone (ErrorCode),                                                         'leere den Inhalt der textBoxErrCodeFanAlone (ErrorCode),
            TextBoxIdNo.Clear()                                                                                                                     'clear the textBoxidNo (Product ID),                                                                   'leere den Inhalt der textBoxIdNo (Produkt ID),
            MessageBox.Show("No products loaded")                                                                                                   'and the MessageBox shows the message "No products loaded".                                            'und die MessageBox zeigt die Nachricht "Keine Produkte geladen" an.
        End If

    End Sub
#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
        TextBoxIdNo.Text = ComboBoxIdNo.Text
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub
#End Region

End Class
