﻿Imports System.Runtime.InteropServices

Public Class Form1

#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function

    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_FAN_CURVE(<MarshalAs(UnmanagedType.AnsiBStr)> fanDescription As String, ByRef buffer As String) As Integer
    End Function

#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()

    End Sub
#End Region
#Region "check_GET_FAN_CURVE*************************************"
    'Checks if products are loaded to avoid crashes while clicking on buttons                       'Überprüft, ob Produkte geladen sind, um abstürze während des Klickens auf die Taste zu verhindern.
    Private Sub check_GET_FAN_CURVE()
        'When number of elements is not empty and error code is 0, then proceed                     'Wenn Produkte geladen sind (eine Anzahl angezeigt wird) und der Error Code 0 ist, fahre fort.
        If (TextBoxElements.Text <> "" And TextBox_DLL_Error_Code.Text = "0") Then

            TextBoxErrCodeGET_FAN_CURVE.Text = Convert.ToString(list_item_GET_FAN_CURVE())





        Else                                                                                          'If no products are loaded or the error code isnt "0",        'Wenn keine Produkte geladen sind oder der Error COde nicht "0" ist,
            '                                                                                         '_clear the fields corresponding to the button                '_leere die Felder entsprechend dem Button
            For Each txt As TextBox In TabPage1.Controls.OfType(Of TextBox)()                         'clear each TextBox from tabPage1 (Results Motor/Fan),        'lösche den Inhalt jeder TextBox von tabPage1 (Results Motor/Fan),
                txt.Text = ""
            Next
            For Each txt As TextBox In TabPage2.Controls.OfType(Of TextBox)()                         'clear each TextBox from tabPage2 (Octave Band),              'lösche den Inhalt jeder Textbox von tabPage2 (Octave Band),
                txt.Text = ""
            Next
            ListBox_GET_FAN_CURVE.Items.Clear()                                                                     'clear the listbox from Results Motor/Fan,                   'leere den Inhalt der Liste von Results Motor/Fan,
            TextBoxErrCodeGET_FAN_CURVE.Clear()                                                                     'clear the textBoxErrCodeFanAlone (ErrorCode),               'leere den Inhalt der textBoxErrCodeFanAlone (ErrorCode),
            TextBoxIdNo.Clear()                                                                                     'clear the textBoxidNo (Product ID),                         'leere den Inhalt der textBoxIdNo (Produkt ID),

            Dim sbMessageBox As System.Text.StringBuilder = New System.Text.StringBuilder()                         '_ and throw a message                                       '_und gebe eine Nachricht aus.
            sbMessageBox.Append("A prerequisite is not set!")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("Please check if you've loaded any products")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("and if the database is bounded!")
            MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set")
        End If
    End Sub
#End Region
#Region "list_item_GET_FAN_CURVE*********************************"
    Private Function list_item_GET_FAN_CURVE()

        Dim errCode As Integer = 99

        Dim fanString As System.String = TextBoxIdNo.Text + ";" + ComboBoxOption.Text + ";" + ComboBoxMounting.Text + ";" + TextBox_Air_Density.Text + ";" + TextBoxAltitude.Text + ";" + TextBoxAirTemperature.Text + ";" + TextBoxPressure.Text + ";" + (((Convert.ToDouble(TextBoxVolume.Text)) / 3600).ToString("#0.00000")) + ";" + TextBox_B.Text + ";" + TextBox_H.Text + ";" + TextBox30.Text + ";" + TextBox31.Text + ";" + TextBox32.Text + ";" + TextBox33.Text + ";" + TextBox34.Text + ";" + TextBox35.Text + ";" + TextBox36.Text + ";" + TextBox37.Text + ";" + TextBox38.Text + ";"
        TextBoxInputData.Text = fanString


        'Initializes fanStringChar with 4000 empty characters.      'Initialisiert fanStringChar mit 4000 leeren Zeichen.
        Dim fanStringChar As String = New String(New Char(), 4000)
        errCode = GET_FAN_CURVE(fanString, fanStringChar)
        show_Results_GET_FAN_CURVE(fanStringChar)


        Return errCode
    End Function
#End Region
#Region "show_Results_GET_VAN_CURVE******************************"
    Private Sub show_Results_GET_FAN_CURVE(fanStringIntern As String)
        Dim result() As String = fanStringIntern.Split(New Char() {";"})

        'Clears all entries in the ListBox.                                                      'Leert alle Einträge in der ListBox.
        ListBox_GET_FAN_CURVE.Items.Clear()
        'Fills each text box with values out of the Array. Only textbox2 gets the specified value from textBoxAirVolume    'Füllt die Textboxen von tabPage1 und tabPage2 mit den Werten aus dem Array. Nur die textBox2 bekommt den angegebenen Wert von textBoxAirVolume.
        TextBox1.Text = result(27)
        TextBox2.Text = TextBoxVolume.Text
        TextBox3.Text = result(0)
        TextBox4.Text = result(1)
        TextBox5.Text = result(2)
        TextBox6.Text = result(3)
        TextBox7.Text = result(4)
        TextBox8.Text = result(5)
        TextBox9.Text = result(6)
        TextBox10.Text = result(26)
        TextBox11.Text = result(18)
        TextBox12.Text = result(19)
        TextBox13.Text = result(20)
        TextBox14.Text = result(21)
        TextBox15.Text = result(22)
        TextBox16.Text = result(23)
        TextBox17.Text = result(24)
        TextBox18.Text = result(25)
        TextBox19.Text = result(9)
        TextBox20.Text = result(10)
        TextBox21.Text = result(11)
        TextBox22.Text = result(12)
        TextBox23.Text = result(13)
        TextBox24.Text = result(14)
        TextBox25.Text = result(15)
        TextBox26.Text = result(16)
        TextBox27.Text = result(17)
        TextBox28.Text = result(8)
        TextBox29.Text = result(7)
        '/*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        'Creates the String-Array "List" with the descriptions of the values, from the fans.              'Erstellt das String-Array "List" mit den Beschreibungen, der Werte, der Lüfter.
        Dim List(30) As String
        List(0) = "      (n [1/min])"
        List(1) = "      (Pe [W])"
        List(2) = "      (I [A])"
        List(3) = "      (ηe [%])"
        List(4) = "     (U control [V])"
        List(5) = "     (Md [Ncm])"
        List(6) = "     (ηo [%])"
        List(7) = "     (LwA(in+out) [dBA])"
        List(8) = "     (LwA(in) [dBA])"
        List(9) = "     (LwA(out) [dBA])"
        List(10) = "    (Lw_62.5_Hz (in) [dB])"
        List(11) = "    (Lw_125__Hz (in) [dB])"
        List(12) = "    (Lw_250__Hz (in) [dB])"
        List(13) = "    (Lw_500__Hz (in) [dB])"
        List(14) = "    (Lw_1000_Hz (in) [dB])"
        List(15) = "    (Lw_2000_Hz (in) [dB])"
        List(16) = "    (Lw_4000_Hz (in) [dB])"
        List(17) = "    (Lw_8000_Hz (in) [dB])"
        List(18) = "    (Lw_62.5_Hz (out) [dB])"
        List(19) = "    (Lw_125__Hz (out) [dB])"
        List(20) = "    (Lw_250__Hz (out) [dB])"
        List(21) = "    (Lw_500__Hz (out) [dB])"
        List(22) = "    (Lw_1000_Hz (out) [dB])"
        List(23) = "    (Lw_2000_Hz (out) [dB])"
        List(24) = "    (Lw_4000_Hz (out) [dB])"
        List(25) = "    (Lw_8000_Hz (out) [dB])"
        List(26) = "    (pf [Pa])"
        List(27) = "    (pfs[Pa])"
        List(28) = "    (qv [m³/h])"

        Dim counter As Integer

        For counter = 0 To 29 Step +1                                           'A for-loop counts from 0 to 29 and                                                             'Eine for-Schleife zählt von 0 auf 29 und
            ListBox_GET_FAN_CURVE.Items.Add(result(counter) + List(counter))    '_fills the listbox with the values from the dll and the descriptions from the array "List".    '_und füllt die Listbox mit den Werten von der DLL und den Beschreibungen aus dem Array "List".
        Next
    End Sub
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click    'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                 'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                       'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                           'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                    'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                    'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                     'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                      'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                         'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub

    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              /Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           /Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   /Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             /Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         /Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           /Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         /Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       /Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If
    End Sub
    Private Sub ButtonGET_FAN_CURVE_Click(sender As System.Object, e As System.EventArgs) Handles ButtonGET_FAN_CURVE.Click
        check_GET_FAN_CURVE()
    End Sub
#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
        TextBoxIdNo.Text = ComboBoxIdNo.Text
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub

    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_psf_pa_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_psf_pa.CheckedChanged
        If CheckBox_psf_pa.Checked = True Then
            TextBox30.Text = "psf"
        Else
            TextBox30.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_LwA_in_dBA_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_LwA_in_dBA.CheckedChanged
        If CheckBox_LwA_in_dBA.Checked = True Then
            TextBox36.Text = "LwA_in"
        Else
            TextBox36.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_I_A_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_I_A.CheckedChanged
        If CheckBox_I_A.Checked = True Then
            TextBox35.Text = "I"
        Else
            TextBox35.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_η_se_pro_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_η_se_pro.CheckedChanged
        If CheckBox_η_se_pro.Checked = True Then
            TextBox34.Text = "eta_se"
        Else
            TextBox34.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_η_e_pro_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_η_e_pro.CheckedChanged
        If CheckBox_η_e_pro.Checked = True Then
            TextBox33.Text = "eta_e"
        Else
            TextBox33.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_n_1min_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_n_1min.CheckedChanged
        If CheckBox_n_1min.Checked = True Then
            TextBox32.Text = "n"
        Else
            TextBox32.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_pe_w_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_pe_w.CheckedChanged
        If CheckBox_pe_w.Checked = True Then
            TextBox31.Text = "Pe"
        Else
            TextBox31.Text = ""
        End If
    End Sub
    'if you click a checkbox the textbox will show which graph you also want to have in the emf file. // Wenn man eine checkbox anklickt, zeigt die Textbox an, welchen Graph man ebenfalls in der emf Datei haben möchte. 
    'With another click on the same checkbox you can prevent on having another Graph in the emf file. // Mit einem weiteren Klick auf der selben Checkbox verhindert man, dass ein weiterer Graph in der emf vorhanden ist.
    Private Sub CheckBox_LwA_out_dBA_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox_LwA_out_dBA.CheckedChanged
        If CheckBox_LwA_out_dBA.Checked = True Then
            TextBox37.Text = "LwA_out"
        Else
            TextBox37.Text = ""
        End If
    End Sub
#End Region
End Class
