﻿Imports System.Runtime.InteropServices
Imports System.Text

Public Class Form1
#Region "globale Variablen***************************************"
    Dim sbKEY As StringBuilder = New StringBuilder()
    Dim sbSIZE As StringBuilder = New StringBuilder()
    Dim sbTYP As StringBuilder = New StringBuilder()
    Dim sbISOCLASS As StringBuilder = New StringBuilder()
    Dim sbPROTECTION As StringBuilder = New StringBuilder()
    'The array size of dbOUTPUT should be 1 more than its equivalent        'Die Arraygröße von dbOUTPUT sollte 1 größer sein als sein äquvalent-Array 
    '_ array in the DLL, because of the length prefix in Delphi. This       '_in der DLL, wegen dem längen prefix in Delphi. Dieses
    '_ length prefix defines the length of the dataset in memory.           '_längen prefix definiert die Länge vom Datensatz im Speicher.
    '_ Without this prevention the storage position in memory will be       '_Ohne diese Vorbeugung, würde die Speicherposition im Speicher 
    '_ overwritten.                                                         '_überschreiben werden. 
    Dim dbOUTPUT(50) As Double
    Dim z1 As Integer = New Integer()
    Dim z2 As Integer = New Integer()
#End Region
#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function

    'KEY, SIZE and the other StringBuilder parameters are Arrays of AnsiChar in Delphi.
    'It's important to marshal these AnsiChar Arrays to StringBuilder, because of
    '_ the compatibility to Delphi Code.
    'OUTPUT is an Array of Double in Delphi, so it's here too.
    <DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_STANDARDS_FANMOTOR( _
        <MarshalAs(UnmanagedType.LPStr)> KEY As StringBuilder, _
        <MarshalAs(UnmanagedType.LPStr)> SIZE As StringBuilder, _
        <MarshalAs(UnmanagedType.LPStr)> TYP As StringBuilder, _
        <MarshalAs(UnmanagedType.LPStr)> ISOCLASS As StringBuilder, _
        <MarshalAs(UnmanagedType.LPStr)> PROTECTION As StringBuilder, _
        z1 As Integer, _
        z2 As Integer, _
        <MarshalAs(UnmanagedType.LPArray)> OUTPUT() As Double) _
        As Integer
    End Function



#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()

    End Sub
#End Region
#Region "get_input_value*****************************************"
    'Reads the manually specified product data out of the fields                                'Liest die, manuel angegebenen, Produktdaten aus den Feldern aus.
    Private Sub get_input_value()
        sbKEY.Append(TextBoxIdNo.Text)
    End Sub
#End Region
#Region "list_item_standards_fanmotor****************************"
    Private Function list_item_standards_fanmotor() As Integer
        Dim errCodeStandards As Integer = 99     'Creates the variable "errCodeStandards" with the value 99.     'Erstellt die Variable "errCodeStandards" with the value 99.

        errCodeStandards = GET_STANDARDS_FANMOTOR(sbKEY, sbSIZE, sbTYP, sbISOCLASS, sbPROTECTION, z1, z2, dbOUTPUT)  'errCodeStandards get all the information from the DLL,            'errCodeStandards bekommt alle Informationen von der DLL,
        show_Results_Standards_Fanmotor(errCodeStandards)                                                            '_and get passed to the show_Results_Standards_FanMotor function.  '_und wird zu der show_Results_Standards_Fan_Motor Funktion weitergeleitet.

        'Clearing these arrays and StringBuilder for its next use          'Leert die Arrays und den StringBuilder für die nächste Benutzung.
        Array.Clear(dbOUTPUT, 0, dbOUTPUT.Length)
        sbSIZE.Clear()
        sbTYP.Clear()
        sbISOCLASS.Clear()
        sbPROTECTION.Clear()
        sbKEY.Clear()

        Return errCodeStandards
    End Function
#End Region
#Region "show_Results_Standards_Fanmotor*************************"
    'Displays the whole data of a product in the text boxes.                                    'Zeigt alle Daten eines Produktes in den Textboxen an.
    Private Sub show_Results_Standards_Fanmotor(errCodeStandardsIntern As Integer)

        richTextBoxOutputData.Clear()

        textBoxErrCodeStandards.Text = errCodeStandardsIntern.ToString()

        textBoxSize.Text = sbSIZE.ToString()
        textBoxTyp.Text = sbTYP.ToString()
        textBoxIsoclass.Text = sbISOCLASS.ToString()
        textBoxProtection.Text = sbPROTECTION.ToString()

        textBox0.Text = dbOUTPUT(0).ToString("#0")
        textBox2.Text = dbOUTPUT(2).ToString("#0.00")
        textBox3.Text = dbOUTPUT(3).ToString("#0")
        textBox4.Text = dbOUTPUT(4).ToString("#0.00")
        textBox5.Text = dbOUTPUT(5).ToString("#0")
        textBox6.Text = dbOUTPUT(6).ToString("#0.00")
        textBox7.Text = dbOUTPUT(7).ToString("#0.00")
        textBox8.Text = dbOUTPUT(8).ToString("#0.000")
        textBox9.Text = dbOUTPUT(9).ToString("#0.00")
        textBox10.Text = dbOUTPUT(10).ToString("#0.00")
        textBox11.Text = dbOUTPUT(11).ToString("#0.00")
        textBox12.Text = dbOUTPUT(12).ToString("#0.000")
        textBox13.Text = dbOUTPUT(13).ToString("#0.0")
        textBox14.Text = dbOUTPUT(14).ToString("#0.0")
        textBox15.Text = dbOUTPUT(15).ToString("#0.0")
        textBox16.Text = dbOUTPUT(16).ToString("#0.00")
        textBox17.Text = dbOUTPUT(17).ToString("#0.00")
        textBox18.Text = dbOUTPUT(18).ToString("#0.00")
        textBox19.Text = dbOUTPUT(19).ToString("#0.00")
        textBox20.Text = dbOUTPUT(20).ToString("#0.00")

        richTextBoxOutputData.Text += "KEY: " + sbKEY.ToString() + vbCrLf
        richTextBoxOutputData.Text += "--------------------------------------------------------------------" + vbCrLf

        richTextBoxOutputData.Text += "Output SIZE:" + vbTab + vbTab + sbSIZE.ToString() + vbCrLf  'Größe
        richTextBoxOutputData.Text += "Output TYP:" + vbTab + vbTab + sbTYP.ToString() + vbCrLf    'Typ
        richTextBoxOutputData.Text += "Output ISOCLASS:" + vbTab + vbTab + sbISOCLASS.ToString() + vbCrLf 'Isoklasse
        richTextBoxOutputData.Text += "Output PROTECTIONS:" + vbTab + sbPROTECTION.ToString() + vbCrLf    'Schutz
        richTextBoxOutputData.Text += "--------------------------------------------------------------------" + vbCrLf

        richTextBoxOutputData.Text += "max. Luftvolumenstrom [m³/h]:" + vbTab + vbTab + vbTab + dbOUTPUT(2).ToString("#0.00") + vbCrLf    'max. Airvolume flow
        richTextBoxOutputData.Text += "max. zulässige Drehzahl [1/min]:" + vbTab + vbTab + dbOUTPUT(3).ToString("#0") + vbCrLf            'max. Rounds per minute
        richTextBoxOutputData.Text += "max. Druckdifferenz-total [Pa]:" + vbTab + vbTab + vbTab + dbOUTPUT(4).ToString("#0.00") + vbCrLf  'max. presussre difference
        richTextBoxOutputData.Text += "Verfügbare Drehzahlstufen:" + vbTab + vbTab + vbTab + dbOUTPUT(5).ToString("#0") + vbCrLf          'avialable speed steps
        richTextBoxOutputData.Text += "elektr. Nennspannung [V]:" + vbTab + vbTab + vbTab + dbOUTPUT(6).ToString("#0.00") + vbCrLf        'Nominal voltage
        richTextBoxOutputData.Text += "Anschlußphasen (Anzahl):" + vbTab + vbTab + vbTab + dbOUTPUT(7).ToString("#0.00") + vbCrLf         'Number of phases
        richTextBoxOutputData.Text += "Elektr. Nennleistung [kW]:" + vbTab + vbTab + vbTab + dbOUTPUT(8).ToString("#0.000") + vbCrLf      'Nominal power
        richTextBoxOutputData.Text += "Elektr. Nennstromaufnahme [A]:" + vbTab + vbTab + dbOUTPUT(9).ToString("#0.00") + vbCrLf           'Current draw
        richTextBoxOutputData.Text += "max. Anlaufstrom [A]:" + vbTab + vbTab + vbTab + dbOUTPUT(10).ToString("#0.00") + vbCrLf           'Starting current max.
        richTextBoxOutputData.Text += "max. Anlaufzeit [s]:" + vbTab + vbTab + vbTab + vbTab + dbOUTPUT(11).ToString("#0.00") + vbCrLf    'Starting time max.
        richTextBoxOutputData.Text += "max. Leistungsaufnahme [kW]:" + vbTab + vbTab + dbOUTPUT(12).ToString("#0.000") + vbCrLf           'max. input
        richTextBoxOutputData.Text += "max. Stromaufnahme [A]:" + vbTab + vbTab + vbTab + dbOUTPUT(13).ToString("#0.0") + vbCrLf          'max. current consumption
        richTextBoxOutputData.Text += "max. Umgebungstemp [°C]:" + vbTab + vbTab + vbTab + dbOUTPUT(14).ToString("#0.0") + vbCrLf         'max. ambient temp.
        richTextBoxOutputData.Text += "Gewicht [kg]:" + vbTab + vbTab + vbTab + vbTab + dbOUTPUT(15).ToString("#0.0") + vbCrLf            'Weight
        richTextBoxOutputData.Text += "Breite [mm]:" + vbTab + vbTab + vbTab + vbTab + dbOUTPUT(16).ToString("#0.00") + vbCrLf            'Width
        richTextBoxOutputData.Text += "Höhe   [mm]:" + vbTab + vbTab + vbTab + vbTab + dbOUTPUT(17).ToString("#0.00") + vbCrLf            'Height
        richTextBoxOutputData.Text += "Tiefe  [mm]:" + vbTab + vbTab + vbTab + vbTab + dbOUTPUT(18).ToString("#0.00") + vbCrLf            'Depth
        richTextBoxOutputData.Text += "Wellendurchmesser [mm]:" + vbTab + vbTab + vbTab + dbOUTPUT(19).ToString("#0.00") + vbCrLf         'Shaft diameter
        richTextBoxOutputData.Text += "zulässige Radialkraft am Wellenende [mm]:" + vbTab + dbOUTPUT(20).ToString("#0.00") + vbCrLf       'Permissible force on the shaft end
        richTextBoxOutputData.Text += "Key:" + vbTab + vbTab + dbOUTPUT(21).ToString("#0") + vbCrLf                                       'key
        richTextBoxOutputData.Text += "fanReference:" + vbTab + dbOUTPUT(22).ToString("#0") + vbCrLf                                      'fanRefernce
        richTextBoxOutputData.Text += "Fehlerparameter:" + vbTab + dbOUTPUT(0).ToString("#0")                                             'error parameter
    End Sub
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click    'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                 'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                       'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                           'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                    'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                    'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                     'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                      'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                         'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub
    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              /Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           /Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   /Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             /Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         /Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           /Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         /Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       /Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If

    End Sub

    Private Sub buttonGetStandardsFanmotor_Click(sender As System.Object, e As System.EventArgs) Handles buttonGetStandardsFanmotor.Click
        If (ComboBoxIdNo.Text <> "" And TextBox_DLL_Error_Code.Text = "0") Then
            get_input_value()
            list_item_standards_fanmotor()

            'If no product is selected, clear the fields               'Wenn kein Produkt ausgewählt ist, leere die Felder
            '_ and throw a message                                     '_und gebe eine Nachricht aus.
        Else
            TextBoxIdNo.Clear()
            textBoxErrCodeStandards.Clear()
            richTextBoxOutputData.Clear()

            'Clears each text box corresponding to its group box                          'leert jede Textbox entsprechend ihrer Gruppenbox.
            For Each textBoxes As TextBox In groupBox5.Controls.OfType(Of TextBox)()
                textBoxes.Clear()
            Next

            Dim sbMessageBox As System.Text.StringBuilder = New System.Text.StringBuilder()
            sbMessageBox.Append("A prerequisite is not set!")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("Please check if you've chosen a product!")
            MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set")
        End If

    End Sub

    Private Sub buttonShowOutputData_Click(sender As System.Object, e As System.EventArgs) Handles buttonShowOutputData.Click
        Select Case richTextBoxOutputData.Visible
            Case True                                              'If OutputData is visible;                                 'Wenn OutputData sichtbar ist,
                richTextBoxOutputData.Visible = False              '_set the richTextBox unvisble                             '_setzte die richTextBox unsichtbar,
                buttonShowOutputData.Text = "Show Output Data"     '_and change the button caption to "Show Output Data"      '_und ändere die Tastenüberschrifft in "Show Output Data".

            Case False                                             'If OutputData is unvisible;                               'Wenn OutputData unsichtbar ist,
                richTextBoxOutputData.Visible = True               '_set the textbox visble                                   '_setzte die richTextBox sichtbar,
                buttonShowOutputData.Text = "Hide Output Data"     '_and change the button caption to "Hide Output Data"      '_und ändere die Tastenüberschrifft in "Hide Output Data".
        End Select
    End Sub



#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
        TextBoxIdNo.Text = ComboBoxIdNo.Text
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub
#End Region
End Class

