﻿Imports System.Runtime.InteropServices

Public Class Form1
#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function

    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function

    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_TECHNICAL_DATA_PC(<MarshalAs(UnmanagedType.AnsiBStr)> fanDescription As String, ByRef buffer As String) As Integer
    End Function
#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()

    End Sub
#End Region
#Region "show_Results_Technical_Data*****************************"
    Private Sub show_Results_Technical_Data(fanStringIntern As String)
        Dim result() As String = fanStringIntern.Split(New Char() {";"})                            'Splitts the technical datas at every ";"                        /Teilt die technischen Daten bei jedem ";"

        listBoxTechnicalData.Items.Clear()                                                          'Clears the ListboxTechnical Data                                'Leert die ListboxTechnical Data             
        textBox50.Text = result(4)                                                                  'and shows the splitted technical data in the right textbox      'und zeigt die geteilten technischen Daten in den richtigen Textboxen
        listBoxTechnicalData.Items.Add("Type: " + vbTab + vbTab + result(4))                        'and in the list with a tabulator separation (vbTab)             'und in der Liste, mit einer Tabulator-Trennung (vbTab) an.
        textBox51.Text = result(3)
        listBoxTechnicalData.Items.Add("Max. fan speed: " + vbTab + result(3) + " (1/min)")
        textBox52.Text = result(2)
        listBoxTechnicalData.Items.Add("Current draw: " + vbTab + result(2) + " (A)")
        textBox53.Text = result(1)
        listBoxTechnicalData.Items.Add("Input power: " + vbTab + result(1) + " (W)")
        textBox54.Text = result(0)
        listBoxTechnicalData.Items.Add("Nominal voltage: " + vbTab + result(0) + " (V)")
        textBox55.Text = result(5)
        listBoxTechnicalData.Items.Add("Discharge area: " + vbTab + result(5) + " (m^2)")
        textBox1.Text = result(6)
        listBoxTechnicalData.Items.Add("Frequency: " + vbTab + result(6) + " [%]")
        textBox2.Text = result(7)
        listBoxTechnicalData.Items.Add("isulation class: " + vbTab + result(7))
        textBox3.Text = result(8)
        listBoxTechnicalData.Items.Add("Protection lass: " + vbTab + result(8))
        textBox4.Text = result(9)
        listBoxTechnicalData.Items.Add("ErP class: " + vbTab + result(9))
        textBox5.Text = result(12)
        listBoxTechnicalData.Items.Add("cos phi:  " + vbTab + vbTab + result(12))
        textBox6.Text = result(13)
        listBoxTechnicalData.Items.Add("Motor pole: " + vbTab + result(13))
        textBox7.Text = result(14)
        listBoxTechnicalData.Items.Add("Motor wiring: " + vbTab + result(14))
        textBox8.Text = result(15)
        listBoxTechnicalData.Items.Add("η es (ERP): " + vbTab + result(15) + " [%]")
        textBox9.Text = result(10)
        listBoxTechnicalData.Items.Add("thermal winding")
        listBoxTechnicalData.Items.Add("protection: " + vbTab + result(10))
    End Sub
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click    'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                 'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                       'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                           'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                    'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                    'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                     'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                      'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                         'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub
    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              'Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           'Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   'Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             'Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         'Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           'Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         'Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       'Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If

    End Sub
    Private Sub buttonGetTechnicalDataPC_Click(sender As Object, e As EventArgs) Handles buttonGetTechnicalDataPC.Click
        If (TextBoxElements.Text <> "" And TextBox_DLL_Error_Code.Text = "0") Then                                'When products are loaded and error code is 0, then proceed                                              'Wenn ein Produkt geladen ist und der ErrorCode "0" ist, fahre fort.    
            Dim errCode As Integer = 99                                                                           'ErrCode get the value 99                                                                                'Errcode bekommt den Wert 99.
            Dim fanString As String = textBoxIdNoTechnicalData.Text + ""                                          'Read the product ID number                                                                              'Liest die Produkt ID ein.                                                      
            Dim fanStringChar As String = New String(New Char(), 4000)                                            'Initializes fanStringChar with 4000 empty characters                                                    'Initialisiert einen fanStringChar mit 4000 leeren characters. 

            errCode = GET_TECHNICAL_DATA_PC(fanString, fanStringChar)                                             'Get the real Error Code and read the technical data from the product ID.                                'Liest den richtigen Error Code und die technischen Daten der Produkt ID ein.
            textBoxErrCodeTechnicalData.Text = Convert.ToString(errCode)                                          'Shows the Error Code in the Textbox "textBoxErrCodeTechnicalData"                                       'Zeigt den Error Code in der Textbox "textBoxErrCodeTechnicalData" an.
            show_Results_Technical_Data(fanStringChar)                                                            'Passes the fanstringChar with the technical data to the function "show_Results_Technical_Data           'Gibt den fanStringChar mit den technischen Daten an die Funktion "show_Results_Technical_Data weiter.

        Else                                                                                                      'If no product is selected, clear the fields and throw a message                                         'Wenn kein Produkt ausgewählt ist, leere die Felder und gebe eine Nachricht aus. 
            textBoxErrCodeTechnicalData.Text = ""
            textBoxIdNoTechnicalData.Text = ""
            listBoxTechnicalData.Items.Clear()
            textBox50.Text = ""
            textBox51.Text = ""
            textBox52.Text = ""
            textBox53.Text = ""
            textBox54.Text = ""
            textBox55.Text = ""
            textBox1.Text = ""
            textBox2.Text = ""
            textBox3.Text = ""
            textBox4.Text = ""
            textBox5.Text = ""
            textBox6.Text = ""
            textBox7.Text = ""
            textBox8.Text = ""
            textBox9.Text = ""

            Dim sbMessageBox As System.Text.StringBuilder = New System.Text.StringBuilder()
            sbMessageBox.Append("A prerequisite is not set!")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("Please check if you've loaded any products")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("and if the database is bounded!")
            MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set")
        End If
    End Sub
#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
        textBoxIdNoTechnicalData.Text = ComboBoxIdNo.Text
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub
#End Region
End Class
