﻿Imports System.Runtime.InteropServices

Public Class Form1
#Region "externe DLL Einbindung**********************************"
    'Imports the DLL and grants a compatibled access to its functions.                              'Importiert die DLL und gewährt einen kompatiblen Zugang zu ihren Funktionen.
    '(The DLL file has to be in the same folder as the EXE!)                                        '(Die DLL-Datei muss im selben Ordner wie die Exe sein!)

    'Attribute DLLImport affects the underneath function.                                           'Das Attribut DLLImport wirkt sich auf die untenstehenden Funktionen aus. 
    'The DLL's name.                                                                                'Der DLL-Name.	  
    'Method call for execution of the DLL function.                                                 'Methodenaufruf zur Ausführung der DLL funktion
    'Charset adapted to Delpi DLL(here Ansi, not Unicode).                                          'Charset wird der Delphi DLL angepasst (Hier wird Ansi verwendet, in Delphi Unicode).
    'Call the DLL function with return to Integer                                                   'Aufruf der Dll funktion mit dem Rückgabewert vom Typ Integer
    'Mapping (get compatibility) with MarshalAs.                                                    'Kompatibilität mit "MarshlAs" bekommen
    '...in ANSI character set with prefix length										            '...in ANSI Zeichen, mit dem prefix länge gesetzt.
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.StdCall, CharSet:=System.Runtime.InteropServices.CharSet.Ansi)>
    Public Shared Function SET_XML_PATH_PC(<System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.AnsiBStr)> path_PAnsiChar As String) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function GET_PRODUCTS_PC(<MarshalAs(UnmanagedType.AnsiBStr)> ByRef fanDescription As String) As Integer
    End Function

    <System.Runtime.InteropServices.DllImport("EbmPapstFan.dll", CallingConvention:=CallingConvention.StdCall, CharSet:=CharSet.Ansi)>
    Public Shared Function SEARCH_PRODUCTS(<MarshalAs(UnmanagedType.AnsiBStr)> fanDescription As String, ByRef buffer As String) As Integer
    End Function

#End Region
#Region "show_results********************************************"
    'Lists all from the database received products                                              'Liste alle, von der Datenbank erhaltenen, Produkte auf.
    Private Sub show_results(productsIntern As Integer, fanStringIntern As String)
        Dim block As Integer = 0
        Dim number As Integer = 0

        'Clear all relevant fields before rewriting them                                        'Reinigt alle relevanten Felder, bevor sie Überschrieben werden.   
        ListBoxProducts.Items.Clear()
        ComboBoxIdNo.Items.Clear()
        ComboBoxType.Items.Clear()

        'splits the data containing String at every semicolon                                   'Teilt den Daten enthaltenen String bei jedem Semikolon.
        Dim result() As String = fanStringIntern.Split(";")
        'Each block is a pre splitted String.                                                   'Jeder Block ist ein vorgeteilter String
        'Each number is a line (row or item) in the listBox.                                    'Jede Nummer ist eine Linie (Reihe oder Item) in der ListBox.
        'This loop lists the products by its ID and Type in each line.                          'Die Schleife listet alle Produkte nach ihrer ID und ihrem Typen in jede Zeile auf.

        Do While block < result.Length - 1
            number += 1
            ComboBoxIdNo.Items.Add(result(block))
            ListBoxProducts.Items.Add(number & ": " & result(block) + " | " & result(block + 1))
            ComboBoxType.Items.Add(result(block + 1))
            block += 2
        Loop

        fanStringIntern = ""

        'Insert two new lines at the listBox's beginning for a formated view                    'Fügt 2 neue Zeilen am Anfang der Liste ein, für eine Übersicht.
        ListBoxProducts.Items.Insert(0, "Number of existing ventilators: " & number)
        ListBoxProducts.Items.Insert(1, "-------------------------------------------")
        'Displays the the first Item in each comboBox                                           'Zeigt das erste Item (Produkt) in den beiden Auswahlboxen an(Combobox).
        ComboBoxIdNo.SelectedIndex = 0
        ComboBoxType.SelectedIndex = 0

        TextBoxElements.Text = number.ToString()

    End Sub
#End Region
#Region "check_search_products***********************************"
    'Checks if products are loaded to avoid crashes while clicking on buttons                       'Überprüft, ob Produkte geladen sind, um abstürze während des Klickens auf die Taste zu verhindern.
    Private Sub check_search_products()
        'When number of elements is not empty and error code is 0, then proceed                     'Wenn Produkte geladen sind (eine Anzahl angezeigt wird) und der Error Code 0 ist, fahre fort.
        If (TextBoxElements.Text <> "" And TextBox_DLL_Error_Code.Text = "0") Then

            textBoxNumberOfElementsSearchProducts.Text = Convert.ToString(list_item_SearchProducts())

        Else                                                                                        'If no products are loaded or the error code isnt "0",       'Wenn keine Produkte geladen sind oder der Error COde nicht "0" ist,   
            Clear_Search_Products()                                                                 '_clear the fields corresponding to the button               '_leere die Felder entsprechend dem Button
            Dim sbMessageBox As System.Text.StringBuilder = New System.Text.StringBuilder()         '_ and throw a message                                       '_und gebe eine Nachricht aus.
            sbMessageBox.Append("A prerequisite is not set!")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("Please check if you've loaded any products")
            sbMessageBox.Append(vbCrLf)
            sbMessageBox.Append("and if the database is bounded!")
            MessageBox.Show(sbMessageBox.ToString(), "Prerequisite not set")
        End If
    End Sub
#End Region
#Region "Clear SearchProducts************************************"
    'Clear all fields from SearchProducts               /Leert alle Felder von SearchProducts

    Private Sub Clear_Search_Products()
        textBoxNumberOfElementsSearchProducts.Text = ""
        listBox_search_products.Items.Clear()
        textBoxAirVolume.Text = "6000"
        textBoxPressureDifference.Text = "450"
        textBoxToleranz.Text = "50"
        textBoxAirDensity.Text = "1,15"
        Edit_Breite_Box.Text = "600"
        Edit_Hoehe_Box.Text = "600"
    End Sub
#End Region
#Region "list_item_SearchProducts********************************"
    Private Function list_item_SearchProducts()
        'Create Error Code with value 99.                               'Erstellt die variable Error Code mit dem Wert 99.  
        Dim errCode As Integer = 99
        'IdNo of the required product                                   'Liest die Produkt ID vom benötigten Produkt ein.
        'Creates a String with the manually specified data.             'Erstellt einen String mit den manuell angegeben Daten.
        Dim fanString As System.String = textBoxAirVolume.Text + ";" + textBoxPressureDifference.Text + ";" + textBoxToleranz.Text + ";" + textBoxAirDensity.Text + ";" + Edit_Breite_Box.Text + ";" + Edit_Hoehe_Box.Text + ";"


        'Initializes fanStringChar with 4000 empty characters.          'Initialisiert fanStringChar mit 4000 leeren Zeichen.
        Dim fanStringChar As String = New String(New Char(), 4000)
        errCode = SEARCH_PRODUCTS(fanString, fanStringChar)
        show_Results_search_products_Data(fanStringChar)
        Return errCode
    End Function
#End Region
#Region "show_Results_search_products_Data***********************"
    Private Sub show_Results_search_products_Data(fanStringIntern As String)
        Dim result() As String = fanStringIntern.Split(New Char() {";"})
        Dim Anz As Integer = 0
        Dim count1 As Integer = 0
        Dim count2 As Integer = 1
        Dim count3 As Integer = 2
        Dim count4 As Integer = 3
        Dim count5 As Integer = 4
        Dim count6 As Integer = 5
        Dim limit As Integer = result.Length - 2


        'Clear the listbox befor filling it.                                                           'leere die ListBox vor dem Befüllen.
        listBox_search_products.Items.Clear()
        'The vbTab formats the output listitems with a tabulator separation.                           'Der vbTab formatiert den Inhalt, vom Output, der Listbox mit einer Tabulator-Trennung.
        listBox_search_products.Items.Insert(0, "IdNo" + vbTab + vbTab + "Typ" + vbTab + vbTab + "n [1/min]" + vbTab + vbTab + "Pe [W]" + vbTab + vbTab + "ηe [%]" + vbTab + vbTab + "ErrorCode")

        For Anz = 0 To limit + 1
            'Limit is the length from result -2 (limit = 41, result = 43),because                      'Limit ist die Länge von result -2 (Limit = 41, result =43);
            '_the value from count1 is in the last step 42 and this Value doesn´t exist and            '_da der Wert von count1 im letzten Schritt 42 wird und dieser Wert nicht existiert,
            '_would be creating an error. So if count1 is bigger than limit, stop adding lines.        '_würde er einen Fehler verursachen. Also wenn count1 größer als Limit ist, stoppe mit dem füllen.
            '_If limit is bigger than count1, Fill the listbox with the values from result             '_Wenn limit größer als count1 ist, Fülle die ListBox mit den Werten von result,
            '_in the right order.                                                                      '_in der richtigen Reihenfolge.           
            If count1 < limit Then
                listBox_search_products.Items.Add(result(count1) + vbTab + vbTab + result(count2) + vbTab + result(count3) + vbTab + vbTab + result(count4) + vbTab + vbTab + result(count5) + vbTab + vbTab + result(count6))
                count1 = count1 + 6
                count2 = count2 + 6
                count3 = count3 + 6
                count4 = count4 + 6
                count5 = count5 + 6
                count6 = count6 + 6
            End If
            Anz = Anz + 5
        Next
    End Sub
#End Region
#Region "Implementation******************************************"
    Private Sub btn_Set_XML_Path_PC_Click(sender As Object, e As EventArgs) Handles btn_Set_XML_Path_PC.Click    'if button Set_XML_Path_PC is clicked,                     'Wenn der Button Set_XML_Path_PC geklickt wird,
        Dim ErrorCode As Integer                                                                                 'create variable from type Integer,                        'erstelle die Variable vom Typ Integer,                                                                          
        SET_XML_PATH_PC(TextBox_Pfad.Text)                                                                       'then take the path from the textbox, set the path and     'dann nehme den Pfad von der Textbox, setze ihn und

        ErrorCode = SET_XML_PATH_PC(TextBox_Pfad.Text)                                                           'gave the value from set_xml_path_pc to errorcode.         'gib den Wert von set_xml_path_pc zur Variable errorcode.

        If ErrorCode = 0 Then                                                                                    'If the value is 0,                                        'Wenn der Wert 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "Connected"                                                                    'show the message "Connected" in the textbox_Status.       'zeige die Nachricht "Verbunden" in ihr an.
        Else                                                                                                     'If the value is not 0,                                    'Wenn der Wert nicht 0 ist,
            TextBox_Status.Text = ""                                                                             'clear the textbox_Status and                              'leere die Textbox_Status und
            TextBox_Status.Text = "The path does not exist"                                                      'show the message "The path does not exist".               'zeige die Nachricht "Pfad existiert nicht" in ihr an.
        End If

        TextBox_DLL_Error_Code.Text = ""                                                                         'Clear the textbox_DLL_Error_Code and                      'Leere die Textbox_DLL_Error_Code und 
        TextBox_DLL_Error_Code.Text = Convert.ToString(ErrorCode)                                                'show the orginal ErrorCode in the textbox_DLL_Error_Code. 'zeige den orginal Error Code in ihr an.
    End Sub
    Private Sub ButtonGetProductsPC_Click(sender As Object, e As EventArgs) Handles ButtonGetProductsPC.Click       'If button GetProductsPC is clicked                                                                'Wenn die Taste GetProductsPC geklickt wird,  
        If TextBox_DLL_Error_Code.Text = "0" Then                                                                   'If the shown DLL Error Code is "0":                                                               'Wenn der gezeigte DLL Error Code "0":
            Dim products As Integer = 99                                                                            'Creates "products" with the value 99.                                                             'Erstellt "products" mit dem Wert 99.

            Dim fanStringChar As String = New String(New Char(), 4000)                                              'Initializes fanStringChar with 4000 empty characters.                                             'Initialisiert fanStringChar mit 4000 leeren Zeichen.
            products = GET_PRODUCTS_PC(fanStringChar)                                                               ' products is the amount of readable products out of the database.                                 '"products" is the Anzahl der Lesbaren Produkte in der Datenbank.
            show_results(products, fanStringChar)                                                                   'the passed fanStringChar is an empty String that gets a value when                                'Der "FanStringChar" ist ein leerer String, der seinen Wert bekommt, wenn
            '                                                                                                       'getting it back from the DLL and  this value will be passed to the show_results function then.    'er von der DLL zurück kommt und dieser Wert wird weitergegeben an die "show_result" Funktion.   

        Else                                                                                                        'If the shown DLL ErrorCode is not "0":                                                              /Wenn der gezeigte DLL Error Code nicht "0" ist:
            TextBoxElements.Clear()                                                                                 'The TextboxElements (Number of Elements) becomes cleared.                                           /Die TextboxElements (Anzahl der Elemente) wird geleert.   
            ComboBoxIdNo.Items.Clear()                                                                              'The dropdown menu from ComboBoxIdNo (Product ID) becomes cleared.                                   /Das Auswahlmenü von der ComboBoxIdNo (Produkt ID) wird geleert.
            ComboBoxIdNo.Text = ""                                                                                  'The shown Product ID from ComboBoxIdNo becomes cleared.                                             /Die angezeigte Produkt ID von der ComboBoxIdNo wird gelöscht.
            ComboBoxType.Items.Clear()                                                                              'The dropdown menu from ComboBoxType (Type) becomes cleared.                                         /Das Auswahlmenü von der ComboBoxType (Typ) wird geleert.
            ComboBoxType.Text = ""                                                                                  'The shown Product Type from ComboBoxType becomes cleared.                                           /Der angezeigte Produkt Typ von der ComboBoxType wird gelöscht.
            ListBoxProducts.Items.Clear()                                                                           'The list with all products becomes cleared.                                                         /Die Liste aller Produkte wird geleert. 
            MessageBox.Show("No database selected")                                                                 'And the MassageBox shows the message "No database selected");                                       /Und die MessageBox gibt die Nachricht "Keine Datenbank ausgewählt" aus.
        End If

    End Sub
    Private Sub buttonSearchProducts_Click(sender As System.Object, e As System.EventArgs) Handles buttonSearchProducts.Click
        check_search_products()                                                                                                                    'Check, if all prerequisites search_products are okay.                'Überprüfe, ob alle Vorraussetzungen von search_products erfüllt sind. 
    End Sub


#End Region
#Region "Events**************************************************"
    Private Sub comboBoxIdNo_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxIdNo.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxType.SelectedIndex = ComboBoxIdNo.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxIdNo.SelectedIndex + 2
    End Sub

    Private Sub comboBoxType_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ComboBoxType.SelectedIndexChanged        'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        ComboBoxIdNo.SelectedIndex = ComboBoxType.SelectedIndex                                                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
        ListBoxProducts.SelectedIndex = ComboBoxType.SelectedIndex + 2
    End Sub

    Private Sub listBoxProducts_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBoxProducts.SelectedIndexChanged  'Changes the focus from the Listbox, ComboboxType or ComboboxIdNo,    'Ändert die Auswahl von der Liste bzw. die Anzeige in den beiden Auswahlmenüs,
        If Not ListBoxProducts.SelectedIndex = 0 And Not ListBoxProducts.SelectedIndex = 1 Then                                                    'when you change the selectedIndex from these 3 things.               'wenn man in einem der 3 Felder einen anderen Eintrag auswählt.  
            ComboBoxIdNo.SelectedIndex = ListBoxProducts.SelectedIndex - 2
            ComboBoxType.SelectedIndex = ListBoxProducts.SelectedIndex - 2
        End If
    End Sub
#End Region
End Class
